import { getWebsit } from '@/api/customerManagement.js'

export default function (pam = {}, option = [], placeholder = '请选择操作网点', errMsg = '请选择操作网点') {
  return new Promise((r, j) => {
    const h = this.$createElement
    var _this = this
    var done_ = null
    function tanchuang() {
      _this
        .$msgbox({
          title: placeholder,
          message: h(
            'el-select',
            {
              style: {
                width: '100%'
              },
              props: {
                value: '',
                filterable: true,
                clearable: true,
                size: 'mini'
              },
              ref: 'selectView',
              on: {
                change: e => {
                  _this.$refs.selectView.value = e
                }
              }
            },
            [
              option.map(it => {
                return h('el-option', {
                  props: {
                    key: it.websitId,
                    label: it.name,
                    value: it.websitId
                  }
                })
              })
            ]
          ),
          beforeClose: function (action, instance, done) {
            if (action === 'confirm') {
              if (_this?.$refs?.selectView?.value) {
                done()
              } else {
                done_ = done
                _this.$message({
                  message: errMsg,
                  type: 'warning'
                })
              }
            } else {
              done()
            }
          },
          showCancelButton: true,
          closeOnClickModal: false,
          confirmButtonText: '确定',
          cancelButtonText: '取消'
        })
        .then(_ => {
          if (_this?.$refs?.selectView?.value) {
            r(option?.find(item => item?.websitId === _this?.$refs?.selectView?.value))
            done_?.()
          } else {
            j()
          }
        })
        .catch(_ => {
          j()
        })
    }
    if (option && option.length) {
      tanchuang()
    } else {
      getWebsit({ status: true, ...pam }).then(res => {
        option = res.data
        tanchuang()
      })
    }
  })
}
